package color.Palettes;

import RGBABitmapImage.RGBABitmapImage.RGBA;

import static Graphics2D.colors.colors.CreateRGBColor;

public class Palettes {
    public static RGBA[] GetBlackWhitePalette() {
        RGBA[] palette;

        palette = new RGBA[2];

        palette[0] = CreateRGBColor(0d, 0d, 0d);
        palette[1] = CreateRGBColor(1d, 1d, 1d);

        return palette;
    }

    public static RGBA[] GetRGBPalette() {
        RGBA[] palette;

        palette = new RGBA[3];

        palette[0] = CreateRGBColor(1d, 0d, 0d);
        palette[1] = CreateRGBColor(0d, 1d, 0d);
        palette[2] = CreateRGBColor(0d, 0d, 1d);

        return palette;
    }

    public static RGBA[] GetCMYPalette() {
        RGBA[] palette;

        palette = new RGBA[3];

        palette[0] = CreateRGBColor(0d, 1d, 1d);
        palette[1] = CreateRGBColor(1d, 0d, 1d);
        palette[2] = CreateRGBColor(1d, 1d, 0d);

        return palette;
    }

    public static RGBA [] GetCGAPalette1High() {
        RGBA[] palette;

        palette = new RGBA[4];

        palette[0] = CreateRGBColor(0d, 0d, 0d);
        palette[1] = CreateRGBColor(1d, 85d/256d, 1d);
        palette[2] = CreateRGBColor(85d/256d, 1d, 1d);
        palette[3] = CreateRGBColor(1d, 1d, 1d);

        return palette;
    }

    public static RGBA [] GetCGAPalette0High() {
        RGBA[] palette;

        palette = new RGBA[4];

        palette[0] = CreateRGBColor(0d, 0d, 0d);
        palette[1] = CreateRGBColor(85d/256d, 1d, 85d/256d);
        palette[2] = CreateRGBColor(1d, 85d/256d, 85d/256d);
        palette[3] = CreateRGBColor(1d, 1d, 85d/256d);

        return palette;
    }

    public static RGBA [] GetCGAPalette() {
        RGBA[] palette;

        palette = new RGBA[16];

        palette[0] = CreateRGBColor(0d, 0d, 0d);
        palette[1] = CreateRGBColor(0d, 0d, 170d/256d);
        palette[2] = CreateRGBColor(0d, 170d/256d, 0d);
        palette[3] = CreateRGBColor(0d, 170d/256d, 170d/256d);
        palette[4] = CreateRGBColor(170d/256d, 0d, 0d);
        palette[5] = CreateRGBColor(170d/256d, 0d, 170d/256d);
        palette[6] = CreateRGBColor(170d/256d, 85d/256d, 0d);
        palette[7] = CreateRGBColor(170d/256d, 170d/256d, 170d/256d);

        palette[8] = CreateRGBColor(85d/256d, 85d/256d, 85d/256d);
        palette[9] = CreateRGBColor(85d/256d, 85d/256d, 1d);
        palette[10] = CreateRGBColor(85d/256d, 1d, 85d/256d);
        palette[11] = CreateRGBColor(85d/256d, 1d, 1d);
        palette[12] = CreateRGBColor(1d, 85d/256d, 85d/256d);
        palette[13] = CreateRGBColor(1d, 85d/256d, 1d);
        palette[14] = CreateRGBColor(1d, 1d, 85d/256d);
        palette[15] = CreateRGBColor(1d, 1d, 1d);


        return palette;
    }
}
