package ImageDithering.NoDither;

import RGBABitmapImage.RGBABitmapImage.RGBA;
import RGBABitmapImage.RGBABitmapImage.RGBABitmapImage;

import static Graphics2D.Graphics2D.Graphics2D.*;
import static Graphics2D.colors.colors.GetWhite;
import static color.ColorDistances.ColorDistances.ColorDistance;

public class NoDither {
    public static RGBABitmapImage NoDither(RGBABitmapImage src, RGBA[] palette) {
        RGBABitmapImage dst;
        double x, y, d, m, p;
        boolean mset;
        RGBA c, n, choice;

        m = 0d;
        choice = new RGBA();
        dst = CreateImage(ImageWidth(src), ImageHeight(src), GetWhite());

        for(y = 0d; y < ImageHeight(src); y = y + 1d){
            for(x = 0d; x < ImageWidth(src); x = x + 1d) {
                mset = false;
                c = GetImagePixel(src, x, y);

                for(p = 0d; p < palette.length; p = p + 1d) {
                    n = palette[(int)p];
                    d = ColorDistance(c, n);

                    if(!mset){
                        m = d;
                        mset = true;
                        choice = n;
                    }else{
                        if(d < m){
                            m = d;
                            choice = n;
                        }
                    }
                }

                SetPixel(dst, x, y, choice);
            }
        }

        return dst;
    }
}






