package tests;

import ImageDithering.ExactDither.ExactDither;
import RGBABitmapImage.RGBABitmapImage.RGBABitmapImage;

import static Graphics2D.Graphics2D.Graphics2D.CreateImage;
import static Graphics2D.colors.colors.GetWhite;
import static ImageDithering.NoDither.NoDither.NoDither;
import static ImageDithering.ExactDither.ExactDither.ExactDither;
import static ImageDithering.FloydSteinbergDither.FloydSteinbergDither.FloydSteinbergDither;
import static ImageDithering.SierraDither.SierraDither.SierraDither;
import static color.Palettes.Palettes.GetBlackWhitePalette;

public class tests {
    public static double test(){
        RGBABitmapImage img;

        img = CreateImage(10d, 10d, GetWhite());

        NoDither(img, GetBlackWhitePalette());
        ExactDither(img, GetBlackWhitePalette());
        FloydSteinbergDither(img, GetBlackWhitePalette());
        SierraDither(img, GetBlackWhitePalette());

        return 0d;
    }
}
